import Service from '@ember/service';
import RemoteStorage from 'remotestoragejs';
import { tracked } from '@glimmer/tracking';

export default class Storage extends Service.extend({
  // anything which *must* be merged to prototype here
}) {
  remoteStorage: RemoteStorage;

  @tracked connecting = true;
  @tracked connected = false;

  initialize() {
    this.remoteStorage = new RemoteStorage();
    (<any>window).remoteStorage = this.remoteStorage;
    console.log('rs:', this.remoteStorage);
    this.remoteStorage.access.claim('myfavoritedrinks', 'rw');
    this.remoteStorage.caching.enable('/myfavoritedrinks/');
    this.setupEventHandlers();
  }

  setupEventHandlers () {
    this.remoteStorage.on('ready', () => {
      console.log('rs ready');
    });
    this.remoteStorage.on('connected', () => {
      this.connecting = false;
      this.connected = true;
      console.log('rs connected');
    });
    this.remoteStorage.on('not-connected', () => {
      this.connecting = false;
      this.connected = false;
      console.log('rs not connected');
    });
    this.remoteStorage.on('disconnected', () => {
      this.connected = false;
      console.log('rs disconnected');
    });
    this.remoteStorage.on('connecting', () => {
      this.connecting = true;
      console.log('rs connecting');
    });
    this.remoteStorage.on('sync-done', () => {
      console.log('rs sync done');
    });
  }
}

// DO NOT DELETE: this is how TypeScript knows how to look up your services.
declare module '@ember/service' {
  interface Registry {
    'storage': Storage;
  }
}
